(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/core'), require('@angular/router'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-access', ['exports', 'rxjs', '@angular/core', '@angular/router', 'rxjs/operators'], factory) :
    (factory((global['ngx-access'] = {}),global.rxjs,global.ng.core,global.ng.router,global.rxjs.operators));
}(this, (function (exports,rxjs,i0,i1,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ACCESS_CONFIG = new i0.InjectionToken('ACCESS_CONFIG');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ AccessStrategy = /** @class */ (function () {
        function AccessStrategy() {
        }
        return AccessStrategy;
    }());
    var FakeAccessStrategy = /** @class */ (function (_super) {
        __extends(FakeAccessStrategy, _super);
        function FakeAccessStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} access
         * @return {?}
         */
        FakeAccessStrategy.prototype.has = /**
         * @param {?} access
         * @return {?}
         */
            function (access) {
                return rxjs.of(false);
            };
        FakeAccessStrategy.decorators = [
            { type: i0.Injectable }
        ];
        return FakeAccessStrategy;
    }(AccessStrategy));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} config
     * @param {?=} __1
     * @return {?}
     */
    function flatten(config, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.parse, parse = _c === void 0 ? ( /**
         * @param {?} v
         * @return {?}
         */function (v) { return v; }) : _c, _d = _b.group, group = _d === void 0 ? false : _d, _e = _b.delimiter, delimiter = _e === void 0 ? '.' : _e;
        /** @type {?} */
        var flatConfig = {};
        /**
         * @param {?} path
         * @param {?} value
         * @return {?}
         */
        function setConfig(path, value) {
            if (!flatConfig[path]) {
                flatConfig[path] = new Set();
            }
            flatConfig[path].add(value);
        }
        /**
         * @param {?} path
         * @param {?} prop
         * @return {?}
         */
        function getPath(path, prop) {
            return path
                ? path + delimiter + prop
                : prop;
        }
        /**
         * @param {?} accesses
         * @param {?} prop
         * @param {?} value
         * @param {?} path
         * @return {?}
         */
        function visitor(accesses, prop, value, path) {
            if (Array.isArray(value)) {
                value.forEach(( /**
                 * @param {?} access
                 * @return {?}
                 */function (access) {
                    visitor(accesses, prop, access, path);
                }));
            }
            else if (typeof value === 'object') {
                /** @type {?} */
                var childrenAccesses = children(value, getPath(path, prop));
                if (group) {
                    accesses = accesses.concat(childrenAccesses);
                    accesses.forEach(( /**
                     * @param {?} access
                     * @return {?}
                     */function (access) {
                        setConfig(getPath(path, access.prop), access.action);
                    }));
                }
            }
            else {
                /** @type {?} */
                var expression = parse(value);
                setConfig(getPath(path, prop), expression);
                accesses = accesses.concat({ action: expression, prop: prop });
            }
            return accesses;
        }
        /**
         * @param {?} obj
         * @param {?=} path
         * @return {?}
         */
        function children(obj, path) {
            if (path === void 0) {
                path = '';
            }
            return Object.keys(obj)
                .reduce(( /**
         * @param {?} accesses
         * @param {?} prop
         * @return {?}
         */function (accesses, prop) { return visitor(accesses, prop, obj[prop], path); }), []);
        }
        children(config);
        return flatConfig;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var Operator = {
        AND: 'AND',
        OR: 'OR',
    };
    /** @type {?} */
    var configurationAccess = {};
    /** @type {?} */
    var hasAccessStrategy = ( /**
     * @return {?}
     */function () { return rxjs.of(false); });
    /**
     * @param {?} config
     * @return {?}
     */
    function setConfigurationAccess(config) {
        /**
         * @param {?} expression
         * @return {?}
         */
        function parse(expression) {
            return {
                list: expression.split(' && '),
                operator: Operator.AND
            };
        }
        configurationAccess = flatten(config, { parse: parse, group: true });
    }
    /**
     * @param {?} accessTest
     * @return {?}
     */
    function setHasAccessStrategy(accessTest) {
        hasAccessStrategy = accessTest;
    }
    /**
     * @param {?} expression
     * @return {?}
     */
    function parse(expression) {
        /** @type {?} */
        var arr = expression.split(':');
        return {
            path: (arr[0] || '').replace(' ', ''),
            action: (arr[1] || '').replace(' ', '')
        };
    }
    /**
     * @param {?} accessExpression
     * @return {?}
     */
    function canExpression(accessExpression) {
        /** @type {?} */
        var access = Array.isArray(accessExpression)
            ? accessExpression
            : [accessExpression];
        return rxjs.from(access)
            .pipe(operators.map(( /**
     * @param {?} a
     * @return {?}
     */function (a) { return a.replace(':', '.'); })), operators.mergeMap(( /**
         * @param {?} a
         * @return {?}
         */function (a) { return can(a); })), operators.reduce(( /**
         * @param {?} acc
         * @param {?} value
         * @return {?}
         */function (acc, value) { return acc || value; }), false));
    }
    /**
     * @param {?} path
     * @return {?}
     */
    function can(path) {
        try {
            /** @type {?} */
            var access = configurationAccess[path];
            if (!!access) {
                return testAccess(Array.from(access));
            }
            console.error("Undefined path " + path);
            return rxjs.of(false);
        }
        catch (e) {
            console.error(e);
            return rxjs.of(false);
        }
    }
    /**
     * @param {?} access
     * @param {?} op
     * @param {?} predicate
     * @param {?} init
     * @return {?}
     */
    function testAccessReducer(access, op, predicate, init) {
        return rxjs.from(( /** @type {?} */(access)))
            .pipe(operators.mergeMap(( /**
     * @param {?} currentAccess
     * @return {?}
     */function (currentAccess) { return testAccess(currentAccess, op); })), operators.reduce(predicate, init));
    }
    /**
     * @param {?} access
     * @param {?=} op
     * @return {?}
     */
    function testAccess(access, op) {
        if (op === void 0) {
            op = Operator.OR;
        }
        return Array.isArray(access)
            ? (op === Operator.AND)
                ? testAccessReducer(access, op, ( /**
                 * @param {?} acc
                 * @param {?} value
                 * @return {?}
                 */function (acc, value) { return acc && value; }), true)
                : testAccessReducer(access, op, ( /**
                 * @param {?} acc
                 * @param {?} value
                 * @return {?}
                 */function (acc, value) { return acc || value; }), false)
            : typeof access === 'string'
                ? hasAccessStrategy(access)
                : testAccess(access.list, access.operator);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessService = /** @class */ (function () {
        function AccessService(config, accessStrategy) {
            setHasAccessStrategy(( /**
             * @param {?} accessName
             * @return {?}
             */function (accessName) { return accessStrategy.has(accessName); }));
            setConfigurationAccess(config.accesses || {});
        }
        /**
         * @param {?} accessExpression
         * @return {?}
         */
        AccessService.prototype.can = /**
         * @param {?} accessExpression
         * @return {?}
         */
            function (accessExpression) {
                return canExpression(accessExpression);
            };
        AccessService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AccessService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] },
                { type: AccessStrategy }
            ];
        };
        /** @nocollapse */ AccessService.ngInjectableDef = i0.defineInjectable({ factory: function AccessService_Factory() { return new AccessService(i0.inject(ACCESS_CONFIG), i0.inject(AccessStrategy)); }, token: AccessService, providedIn: "root" });
        return AccessService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessPathDirective = /** @class */ (function () {
        function AccessPathDirective() {
        }
        AccessPathDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxAccessPath]'
                    },] }
        ];
        AccessPathDirective.propDecorators = {
            ngxAccessPath: [{ type: i0.Input }]
        };
        return AccessPathDirective;
    }());
    var AccessDirective = /** @class */ (function () {
        function AccessDirective(template, viewContainer, accessService, parentAccessPath) {
            this.template = template;
            this.viewContainer = viewContainer;
            this.accessService = accessService;
            this.parentAccessPath = parentAccessPath;
        }
        /**
         * @return {?}
         */
        AccessDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var ngxAccess = this.ngxAccess;
                if (this.parentAccessPath) {
                    var _a = parse(this.parentAccessPath.ngxAccessPath), path_1 = _a.path, action = _a.action;
                    if (this.ngxAccess) {
                        if (Array.isArray(this.ngxAccess)) {
                            ngxAccess = this.ngxAccess.map(( /**
                             * @param {?} access
                             * @return {?}
                             */function (access) { return access.replace('$', path_1); })) + ":" + action;
                        }
                        else {
                            var _b = parse(ngxAccess), childPath = _b.path, childAction = _b.action;
                            ngxAccess = childPath.replace('$', path_1) + ":" + (childAction ? childAction : action);
                        }
                    }
                    else {
                        ngxAccess = path_1 + ":" + action;
                    }
                }
                this.accessService.can(ngxAccess)
                    .subscribe(( /**
             * @param {?} access
             * @return {?}
             */function (access) {
                    return access
                        ? _this.viewContainer.createEmbeddedView(_this.template)
                        : _this.ngxAccessElse
                            ? _this.viewContainer.createEmbeddedView(_this.ngxAccessElse)
                            : null;
                }));
            };
        AccessDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxAccess]'
                    },] }
        ];
        /** @nocollapse */
        AccessDirective.ctorParameters = function () {
            return [
                { type: i0.TemplateRef },
                { type: i0.ViewContainerRef },
                { type: AccessService },
                { type: AccessPathDirective, decorators: [{ type: i0.Optional }, { type: i0.Host }] }
            ];
        };
        AccessDirective.propDecorators = {
            ngxAccess: [{ type: i0.Input }],
            ngxAccessElse: [{ type: i0.Input }]
        };
        return AccessDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessGuard = /** @class */ (function () {
        function AccessGuard(router, accessService, config) {
            this.router = router;
            this.accessService = accessService;
            this.config = config;
        }
        /**
         * @param {?} next
         * @return {?}
         */
        AccessGuard.prototype.canActivate = /**
         * @param {?} next
         * @return {?}
         */
            function (next) {
                var _this = this;
                return this.accessService.can(next.data.expression)
                    .pipe(operators.tap(( /**
             * @param {?} hasAccess
             * @return {?}
             */function (hasAccess) { return !hasAccess && _this.router.navigate([next.data.redirect || _this.config.redirect]); })));
            };
        AccessGuard.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AccessGuard.ctorParameters = function () {
            return [
                { type: i1.Router },
                { type: AccessService },
                { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] }
            ];
        };
        /** @nocollapse */ AccessGuard.ngInjectableDef = i0.defineInjectable({ factory: function AccessGuard_Factory() { return new AccessGuard(i0.inject(i1.Router), i0.inject(AccessService), i0.inject(ACCESS_CONFIG)); }, token: AccessGuard, providedIn: "root" });
        return AccessGuard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessModule = /** @class */ (function () {
        function AccessModule() {
        }
        /**
         * @param {?} config
         * @return {?}
         */
        AccessModule.forRoot = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: AccessModule,
                    providers: [
                        {
                            provide: ACCESS_CONFIG,
                            useValue: {
                                accesses: config.accesses || {},
                                redirect: config.redirect || '/unauthorized',
                            }
                        },
                        config.strategy || {
                            provide: AccessStrategy,
                            useClass: FakeAccessStrategy
                        }
                    ]
                };
            };
        AccessModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [AccessPathDirective, AccessDirective],
                        exports: [AccessPathDirective, AccessDirective]
                    },] }
        ];
        return AccessModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AccessModule = AccessModule;
    exports.AccessPathDirective = AccessPathDirective;
    exports.AccessDirective = AccessDirective;
    exports.setConfigurationAccess = setConfigurationAccess;
    exports.setHasAccessStrategy = setHasAccessStrategy;
    exports.parse = parse;
    exports.canExpression = canExpression;
    exports.flatten = flatten;
    exports.AccessGuard = AccessGuard;
    exports.AccessService = AccessService;
    exports.AccessStrategy = AccessStrategy;
    exports.FakeAccessStrategy = FakeAccessStrategy;
    exports.ACCESS_CONFIG = ACCESS_CONFIG;
    exports.ɵb = AccessDirective;
    exports.ɵa = AccessPathDirective;
    exports.ɵd = AccessStrategy;
    exports.ɵe = FakeAccessStrategy;
    exports.ɵc = AccessService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-access.umd.js.map