import { __extends } from 'tslib';
import { of, from } from 'rxjs';
import { InjectionToken, Injectable, Inject, NgModule, Directive, Input, TemplateRef, ViewContainerRef, Optional, Host, defineInjectable, inject } from '@angular/core';
import { Router } from '@angular/router';
import { map, mergeMap, reduce, tap } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var ACCESS_CONFIG = new InjectionToken('ACCESS_CONFIG');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AccessStrategy = /** @class */ (function () {
    function AccessStrategy() {
    }
    return AccessStrategy;
}());
var FakeAccessStrategy = /** @class */ (function (_super) {
    __extends(FakeAccessStrategy, _super);
    function FakeAccessStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} access
     * @return {?}
     */
    FakeAccessStrategy.prototype.has = /**
     * @param {?} access
     * @return {?}
     */
    function (access) {
        return of(false);
    };
    FakeAccessStrategy.decorators = [
        { type: Injectable }
    ];
    return FakeAccessStrategy;
}(AccessStrategy));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} config
 * @param {?=} __1
 * @return {?}
 */
function flatten(config, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.parse, parse = _c === void 0 ? (/**
     * @param {?} v
     * @return {?}
     */
    function (v) { return v; }) : _c, _d = _b.group, group = _d === void 0 ? false : _d, _e = _b.delimiter, delimiter = _e === void 0 ? '.' : _e;
    /** @type {?} */
    var flatConfig = {};
    /**
     * @param {?} path
     * @param {?} value
     * @return {?}
     */
    function setConfig(path, value) {
        if (!flatConfig[path]) {
            flatConfig[path] = new Set();
        }
        flatConfig[path].add(value);
    }
    /**
     * @param {?} path
     * @param {?} prop
     * @return {?}
     */
    function getPath(path, prop) {
        return path
            ? path + delimiter + prop
            : prop;
    }
    /**
     * @param {?} accesses
     * @param {?} prop
     * @param {?} value
     * @param {?} path
     * @return {?}
     */
    function visitor(accesses, prop, value, path) {
        if (Array.isArray(value)) {
            value.forEach((/**
             * @param {?} access
             * @return {?}
             */
            function (access) {
                visitor(accesses, prop, access, path);
            }));
        }
        else if (typeof value === 'object') {
            /** @type {?} */
            var childrenAccesses = children(value, getPath(path, prop));
            if (group) {
                accesses = accesses.concat(childrenAccesses);
                accesses.forEach((/**
                 * @param {?} access
                 * @return {?}
                 */
                function (access) {
                    setConfig(getPath(path, access.prop), access.action);
                }));
            }
        }
        else {
            /** @type {?} */
            var expression = parse(value);
            setConfig(getPath(path, prop), expression);
            accesses = accesses.concat({ action: expression, prop: prop });
        }
        return accesses;
    }
    /**
     * @param {?} obj
     * @param {?=} path
     * @return {?}
     */
    function children(obj, path) {
        if (path === void 0) { path = ''; }
        return Object.keys(obj)
            .reduce((/**
         * @param {?} accesses
         * @param {?} prop
         * @return {?}
         */
        function (accesses, prop) { return visitor(accesses, prop, obj[prop], path); }), []);
    }
    children(config);
    return flatConfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var Operator = {
    AND: 'AND',
    OR: 'OR',
};
/** @type {?} */
var configurationAccess = {};
/** @type {?} */
var hasAccessStrategy = (/**
 * @return {?}
 */
function () { return of(false); });
/**
 * @param {?} config
 * @return {?}
 */
function setConfigurationAccess(config) {
    /**
     * @param {?} expression
     * @return {?}
     */
    function parse(expression) {
        return {
            list: expression.split(' && '),
            operator: Operator.AND
        };
    }
    configurationAccess = flatten(config, { parse: parse, group: true });
}
/**
 * @param {?} accessTest
 * @return {?}
 */
function setHasAccessStrategy(accessTest) {
    hasAccessStrategy = accessTest;
}
/**
 * @param {?} expression
 * @return {?}
 */
function parse(expression) {
    /** @type {?} */
    var arr = expression.split(':');
    return {
        path: (arr[0] || '').replace(' ', ''),
        action: (arr[1] || '').replace(' ', '')
    };
}
/**
 * @param {?} accessExpression
 * @return {?}
 */
function canExpression(accessExpression) {
    /** @type {?} */
    var access = Array.isArray(accessExpression)
        ? accessExpression
        : [accessExpression];
    return from(access)
        .pipe(map((/**
     * @param {?} a
     * @return {?}
     */
    function (a) { return a.replace(':', '.'); })), mergeMap((/**
     * @param {?} a
     * @return {?}
     */
    function (a) { return can(a); })), reduce((/**
     * @param {?} acc
     * @param {?} value
     * @return {?}
     */
    function (acc, value) { return acc || value; }), false));
}
/**
 * @param {?} path
 * @return {?}
 */
function can(path) {
    try {
        /** @type {?} */
        var access = configurationAccess[path];
        if (!!access) {
            return testAccess(Array.from(access));
        }
        console.error("Undefined path " + path);
        return of(false);
    }
    catch (e) {
        console.error(e);
        return of(false);
    }
}
/**
 * @param {?} access
 * @param {?} op
 * @param {?} predicate
 * @param {?} init
 * @return {?}
 */
function testAccessReducer(access, op, predicate, init) {
    return from((/** @type {?} */ (access)))
        .pipe(mergeMap((/**
     * @param {?} currentAccess
     * @return {?}
     */
    function (currentAccess) { return testAccess(currentAccess, op); })), reduce(predicate, init));
}
/**
 * @param {?} access
 * @param {?=} op
 * @return {?}
 */
function testAccess(access, op) {
    if (op === void 0) { op = Operator.OR; }
    return Array.isArray(access)
        ? (op === Operator.AND)
            ? testAccessReducer(access, op, (/**
             * @param {?} acc
             * @param {?} value
             * @return {?}
             */
            function (acc, value) { return acc && value; }), true)
            : testAccessReducer(access, op, (/**
             * @param {?} acc
             * @param {?} value
             * @return {?}
             */
            function (acc, value) { return acc || value; }), false)
        : typeof access === 'string'
            ? hasAccessStrategy(access)
            : testAccess(access.list, access.operator);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessService = /** @class */ (function () {
    function AccessService(config, accessStrategy) {
        setHasAccessStrategy((/**
         * @param {?} accessName
         * @return {?}
         */
        function (accessName) { return accessStrategy.has(accessName); }));
        setConfigurationAccess(config.accesses || {});
    }
    /**
     * @param {?} accessExpression
     * @return {?}
     */
    AccessService.prototype.can = /**
     * @param {?} accessExpression
     * @return {?}
     */
    function (accessExpression) {
        return canExpression(accessExpression);
    };
    AccessService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AccessService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [ACCESS_CONFIG,] }] },
        { type: AccessStrategy }
    ]; };
    /** @nocollapse */ AccessService.ngInjectableDef = defineInjectable({ factory: function AccessService_Factory() { return new AccessService(inject(ACCESS_CONFIG), inject(AccessStrategy)); }, token: AccessService, providedIn: "root" });
    return AccessService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessPathDirective = /** @class */ (function () {
    function AccessPathDirective() {
    }
    AccessPathDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxAccessPath]'
                },] }
    ];
    AccessPathDirective.propDecorators = {
        ngxAccessPath: [{ type: Input }]
    };
    return AccessPathDirective;
}());
var AccessDirective = /** @class */ (function () {
    function AccessDirective(template, viewContainer, accessService, parentAccessPath) {
        this.template = template;
        this.viewContainer = viewContainer;
        this.accessService = accessService;
        this.parentAccessPath = parentAccessPath;
    }
    /**
     * @return {?}
     */
    AccessDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var ngxAccess = this.ngxAccess;
        if (this.parentAccessPath) {
            var _a = parse(this.parentAccessPath.ngxAccessPath), path_1 = _a.path, action = _a.action;
            if (this.ngxAccess) {
                if (Array.isArray(this.ngxAccess)) {
                    ngxAccess = this.ngxAccess.map((/**
                     * @param {?} access
                     * @return {?}
                     */
                    function (access) { return access.replace('$', path_1); })) + ":" + action;
                }
                else {
                    var _b = parse(ngxAccess), childPath = _b.path, childAction = _b.action;
                    ngxAccess = childPath.replace('$', path_1) + ":" + (childAction ? childAction : action);
                }
            }
            else {
                ngxAccess = path_1 + ":" + action;
            }
        }
        this.accessService.can(ngxAccess)
            .subscribe((/**
         * @param {?} access
         * @return {?}
         */
        function (access) { return access
            ? _this.viewContainer.createEmbeddedView(_this.template)
            : _this.ngxAccessElse
                ? _this.viewContainer.createEmbeddedView(_this.ngxAccessElse)
                : null; }));
    };
    AccessDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxAccess]'
                },] }
    ];
    /** @nocollapse */
    AccessDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: AccessService },
        { type: AccessPathDirective, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    AccessDirective.propDecorators = {
        ngxAccess: [{ type: Input }],
        ngxAccessElse: [{ type: Input }]
    };
    return AccessDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessGuard = /** @class */ (function () {
    function AccessGuard(router, accessService, config) {
        this.router = router;
        this.accessService = accessService;
        this.config = config;
    }
    /**
     * @param {?} next
     * @return {?}
     */
    AccessGuard.prototype.canActivate = /**
     * @param {?} next
     * @return {?}
     */
    function (next) {
        var _this = this;
        return this.accessService.can(next.data.expression)
            .pipe(tap((/**
         * @param {?} hasAccess
         * @return {?}
         */
        function (hasAccess) { return !hasAccess && _this.router.navigate([next.data.redirect || _this.config.redirect]); })));
    };
    AccessGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AccessGuard.ctorParameters = function () { return [
        { type: Router },
        { type: AccessService },
        { type: undefined, decorators: [{ type: Inject, args: [ACCESS_CONFIG,] }] }
    ]; };
    /** @nocollapse */ AccessGuard.ngInjectableDef = defineInjectable({ factory: function AccessGuard_Factory() { return new AccessGuard(inject(Router), inject(AccessService), inject(ACCESS_CONFIG)); }, token: AccessGuard, providedIn: "root" });
    return AccessGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessModule = /** @class */ (function () {
    function AccessModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    AccessModule.forRoot = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: AccessModule,
            providers: [
                {
                    provide: ACCESS_CONFIG,
                    useValue: {
                        accesses: config.accesses || {},
                        redirect: config.redirect || '/unauthorized',
                    }
                },
                config.strategy || {
                    provide: AccessStrategy,
                    useClass: FakeAccessStrategy
                }
            ]
        };
    };
    AccessModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AccessPathDirective, AccessDirective],
                    exports: [AccessPathDirective, AccessDirective]
                },] }
    ];
    return AccessModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccessModule, AccessPathDirective, AccessDirective, setConfigurationAccess, setHasAccessStrategy, parse, canExpression, flatten, AccessGuard, AccessService, AccessStrategy, FakeAccessStrategy, ACCESS_CONFIG, AccessDirective as ɵb, AccessPathDirective as ɵa, AccessStrategy as ɵd, FakeAccessStrategy as ɵe, AccessService as ɵc };

//# sourceMappingURL=ngx-access.js.map